<?php


function inbound_contact_api_find($params = array()) {
    //debug_raw($params);

    $item_nids = array();
    $query = new EntityFieldQuery();
    $query->entityCondition('entity_type', 'inbound_contact')
        ->entityCondition('bundle', 'inbound_contact_bundle');

    if ($params['from']) {
        $query->propertyCondition('created', $params['from'], '>=');
    }

    if ($params['to']) {
        $query->propertyCondition('created', $params['to'], '<=');
    }

    if ($params['lifecycle_stage']) {
        $query->propertyCondition('lifecycle_stage', $params['lifecycle_stage'], '=');
    }

    if ($params['email']) {
        $query->propertyCondition('email', $params['email'], '=');
    }

    if ($params['type']) {
        $query->propertyCondition('type', $params['type'], '=');
    }

    //->propertyCondition('language', $GLOBALS['language']->language);
    //->fieldCondition('field_news_types', 'value', 'spotlight', '=')
    //->fieldCondition('field_photo', 'fid', 'NULL', '!=')
    //->fieldCondition('field_faculty_tag', 'tid', $value)
    //->fieldCondition('field_news_publishdate', 'value', $year. '%', 'like')
    $query->propertyOrderBy('updated', 'DESC');

    //->addMetaData('account', user_load(1)); // Run the query as user 1.
    //$query->addMetaData('debug', 'debug'); // Run the query as user 1.
    $query->addTag('debug'); // Run the query as user 1.

    if ($params['returncount'] == true) {
        return $query->count()->execute();
    }

    if ($params['limit']) {
        $query->range(0, $params['limit']);
    } else {
        $query->range(0, 100);
    }


    $result = $query->execute();

    if (isset($result['inbound_contact'])) {
        $item_ids = array_keys($result['inbound_contact']);
        $entities = entity_load('inbound_contact', $item_ids);
        // Filter Out the unwished data
        foreach ($entities as $entity) {
            $data[] = $entity;
        }
    }
    return $data;
}

function inbound_contact_query_alter($query) {
    if ($query->hasTag('debug')) {
        //    debug_raw((string)$query);
    }
}

function inbound_contact_getCustomers() {
    $params = array(
        'lifecycle_stage'=>3,
        'returncount'=>true
    );
    return inbound_contact_api_find($params);
}

function inbound_contact_getHotleads() {
    $params = array();
    $params['hit_count'] = 10;
    $params['email_not_empty'] = true;
    $params['returncount'] = true;
    return inbound_contact_prospect_filter($params);
}

function inbound_contact_getWarmleads() {
    $params = array();
    //$params['hit_count'] = 1;
    $params['email_not_empty'] = true;
    $params['returncount'] = true;
    return inbound_contact_prospect_filter($params);
}


function inbound_contact_getColdleads() {
    $params = array();
    $params['hit_count'] = 1;
    $params['type'] = 1;
    $params['returncount'] = true;
    return inbound_contact_prospect_filter($params);
}

function inbound_contact_getBots() {
    $params = array(
        'type'=>2,
        'returncount'=>true
    );
    return 'test';
    return inbound_contact_api_find($params);
}

function inbound_contact_getAll() {
    $params = array(
        'returncount'=>true
    );
    return inbound_contact_api_find($params);
}

function inbound_contact_prospect_filter($params = array()) {
    //debug_raw($params);

    $sql = 'SELECT * FROM inbound_contact ic WHERE 1=1 ';

    if ($params['hit_count']) {
        $sql .= ' AND (SELECT count(*) FROM inbound_session_hit WHERE contact_id = ic.id) > '.$params['hit_count'].' ';
    }

    if ($params['email_not_empty']) {
        $sql .= " AND (email != '' OR email != null) ";
    }

    if ($params['type']) {
        $sql .= ' AND type = '.$params['type'].' ';
    }

    $sql .= ' ORDER BY ic.updated DESC ';

    if ($params['limit']) {
        $sql .= ' LIMIT '.$params['limit'];
    }

    //echo $sql.'<br>';
    if ($params['returncount'] == true) {
        return db_query($sql)->rowCount();
    }


    //debug_raw($sql);
    $result = db_query($sql);
    foreach ($result as $row) {
        $item_ids[] = $row->id;
    }
    return entity_load('inbound_contact', $item_ids);

}