<?php

function inbound_contact_info_page() {
    /*
    $content['actions'] = array(
        '#type' => 'item',
        '#markup' => l('Add contact', 'admin/inbound/contact/add'),
    );*/

    $content[] = array(
        '#type' => 'item',
        '#markup' => theme('contact_stats'),
    );

    $content['preface'] = array(
        '#type' => 'item',
        '#markup' => t(''),
    );
    $content['table'] = inbound_contact_list_entities();
    return $content;
}

function inbound_contact_list_entities() {
    $content = array();

    // There were no entities. Tell the user.

    /*
    $content[] = array(
        'form' => drupal_get_form('inbound_contact_overview_form')
    );
    */

    switch ($_GET['filter']) {
        case 'customer':
            $params['lifecycle_stage'] = 3;
            $params['limit'] = $_SESSION['inbound_contact']['overview']['limit'];
            $entities = inbound_contact_api_find($params);
            break;
        case 'hot':
            $params = array();
            $params['hit_count'] = 10;
            $params['email_not_empty'] = true;
            $entities = inbound_contact_prospect_filter($params);
            //debug_raw(json_decode($_GET['data']));
            break;
        case "warm":
            $params = array();
            //$params['hit_count'] = 5;
            //$params['type'] = 1;
            $params['limit'] = 500;
            $params['email_not_empty'] = true;
            $entities = inbound_contact_prospect_filter($params);
            break;
        case "cold":
            $params = array();
            $params['hit_count'] = 1;
            $params['type'] = 1;
            $params['limit'] = 1000;
            //$params['email_not_empty'] = true;
            $entities = inbound_contact_prospect_filter($params);
            break;
        default:
            //$entities = inbound_contact_api_find($_SESSION['inbound_contact']['overview']);
    }

    // Load all of our entities.

    //debug_raw($entities);
    if (!empty($entities)) {
        foreach ($entities as $entity) {
            // Create tabular rows for our entities.

            $datas = (array) json_decode($entity->data);
            //$data_output = '<strong>IP</strong> '.$datas['ip'].'<br>';
            $data_output = '<strong>City/Country</strong> '.$datas['ip_data']->city.', '.$datas['ip_data']->country.'<br>';
            $data_output .= '<strong>Organisation/AS</strong> '.$datas['ip_data']->org.', '.$datas['ip_data']->as.'<br>';
            //$data_output .= 'Referrer: '.$datas['referrer'].'<br>';
            //$data_output .= $datas['agent'].'<br>';
            //debug_raw($sessions);
            $email_parts = explode('@', $entity->email);
            $rows[] = array(
                'data' => array(
                    //'id' => $entity->id,
                    'updated' => format_interval((time()-$entity->updated)),
                    //'persona' => $entity->persona.' '.$entity->type,
                    'data'=> $data_output,
                    //'lifecycle_stage' => $entity->lifecycle_stage,
                    'email' => $entity->email,
                    'first_name' => $entity->firstname,
                    'last_name' => $entity->lastname,
                    'sessions' => $entity->session_count,
                    'hits'=> $entity->hit_count,
                    'comments'=> $entity->comment_count,
                    'view' => l('View', 'admin/inbound/contact/'.$entity->id.''),
                    //'edit' => l('Edit', 'admin/inbound/contact/'.$entity->id.'/edit')
                ),
            );
        }
        // Put our entities into a themed table. See theme_table() for details.
        $content['entity_table'] = array(
            '#theme' => 'table',
            '#rows' => $rows,
            '#header' => array(
                //t('ID'),
                t('Last interaction'),
                //t('Persona'),
                t('Data'),
                //t('Stage'),
                t('E-Mail'),
                t('First name'),
                t('Last name'),
                t('Sessions'),
                t('Hits'),
                t('Comments'),
                t('View'),
                //t('Edit')
            ),
        );
    }
    else {
        // There were no entities. Tell the user.
        $content[] = array(
            '#type' => 'item',
            '#markup' => t('No contacts currently exist.'),
        );
    }
    return $content;
}

function inbound_contact_overview_form() {
    $form['type'] = array(
        '#type' => 'select',
        '#title' => t('type'),
        '#options' => array(0=>'undef', 1=>'human', 2=>'bot'),
        '#default_value' => $_SESSION['inbound_contact']['overview']['contact_type'],
    );

    $form['limit'] = array(
        '#type' => 'select',
        '#title' => t('type'),
        '#options' => array(100=>'100 Kontakt', 1000=>'1000 Kontakt', 10000=>'10000'),
        '#default_value' => $_SESSION['inbound_contact']['overview']['limit'],
    );

    $form['submit'] = array(
        '#type' => 'submit',
        '#value' => t('Filter'),
        '#weight' => 100,
    );
    return $form;
}

function inbound_contact_overview_form_submit($form, &$form_state) {
    $_SESSION['inbound_contact']['overview']['type'] = $form_state['values']['type'];
    $_SESSION['inbound_contact']['overview']['limit'] = $form_state['values']['limit'];
}