<?php

function inbound_contact_webform_submission_presave($node, $submission) {
    //debug_raw($node->webform);
    //debug_raw($submission);
}

function inbound_contact_webform_submission_insert($node, $submission) {
    // Get the Webform version
    $webform_path = drupal_get_path('module', 'webform') . '/webform.info';
    $webform_info = drupal_parse_info_file($webform_path);

    $matches = array();

    if (preg_match('/^(\d+\.x-)?(\d+)\..*$/', $webform_info['version'], $matches)) {
        $webform_major_version = $matches[2];
    }

    if ($submission->is_draft == 1) {
        return;
    }


    foreach ($node->webform['components'] as $data_id => $data) {
        if (!isset($submission->data[$data_id])) {
            continue;
        }
        else {
            // Get the component value (submission structure differs from Webform 3 and 4).
            // https://drupal.org/node/1609324#submission-structure
            $component_data[$data['form_key']] = $webform_major_version <= 3 ? $submission->data[$data_id]['value'] : $submission->data[$data_id];
        }
    }
    //debug_raw($component_data);

    $contactController = entity_get_controller('inbound_contact');
    if (valid_email_address($component_data['e_mail'][0])) {

        // Check if email is already a contact
        $entity_contact = array_shift($contactController->find(array('email'=>$component_data['e_mail'][0])));
        if (count($entity_contact)) {
            $entity_session = inbound_session_load($_SESSION['inbound']['inbound_session']['id']);
            $entity_session->contact_id = $entity_contact->id;
            entity_get_controller('inbound_session')->save($entity_session);
            $entity_contact->type = 1;
            $contactController->save($entity_contact);
        } else {
            // Load contact based on current session
            $entity_session = inbound_session_load($_SESSION['inbound']['inbound_session']['id']);
            $entity_contact = array_shift(entity_load('inbound_contact', array($entity_session->contact_id)));
            $entity_contact->email = $component_data['e_mail'][0];
            $entity_contact->type = 1;
            $contactController->save($entity_contact);
        }


        $entity_hit = new stdClass();
        $entity_hit->session_id = $entity_session->id;
        $entity_hit->contact_id = $entity_session->contact_id;
        $entity_hit->bundle_type = 'standard session hit';
        $entity_hit->created = time();
        $entity_hit->event = 'webform_submission';
        $entity_hit->event_label = 'Webform filled: '.$node->title;
        $entity_hit->event_value = 'node/'.$node->nid;
        $entity_hit = entity_get_controller('inbound_session_hit')->save($entity_hit);


        //debug_raw($_SESSION);
        //debug_raw($entity_contact);

    }

}