function drawChart(data) {
    var data = new google.visualization.DataTable();

    data.addColumn('date', 'Date');
    data.addColumn('number', 'Previous Month');
    data.addColumn('number', 'Current Month');
    data.addColumn('number', 'Current Month Delta');
    data.addColumn('number', 'Goal');
    data.addRows([data]);

    var options = {
        title: 'Website Traffic',
        curveType: 'function',
        legend: { position: 'bottom' },
        pointSize: 2,
        hAxis: {
            title: 'Day',
            gridlines: {
                color: 'transparent'
            }
        },
        vAxis: {
            title: 'Visits',
            format: 'short',
            minValue: 0,
            maxValue: ".($goal).",
            gridlines: {
                color: 'none'
            }
        },
        series: {
            0: { color: '#cccccc', type: 'area' },
            1: { color: '#3288e6', type: 'area' },
            2: { color: '#999999' },
            3: { color: '#e0e0e0', type: 'line', pointShape: { type: 'star', sides: 5, dent: 0.5 } },
        },
        seriesType: 'bars'
    };

    var chart = new google.visualization.ComboChart(document.getElementById('curve_chart'));

    chart.draw(data, options);
}