<?php


function inbound_session_api_find($params = array()) {
    //debug_raw($params);

    $item_nids = array();
    $query = new EntityFieldQuery();
    $query->entityCondition('entity_type', 'inbound_session')
          ->entityCondition('bundle', 'standard session');

    if ($params['from']) {
        $query->propertyCondition('created', $params['from'], '>=');
    }

    if ($params['to']) {
        $query->propertyCondition('created', $params['to'], '<=');
    }

    if ($params['updated_from']) {
        $query->propertyCondition('updated', $params['from'], '>=');
    }

    if ($params['updated_to']) {
        $query->propertyCondition('updated', $params['to'], '<=');
    }

    if ($params['session_type']) {
        $query->propertyCondition('session_type', $params['session_type'], '=');
    }

    if ($params['contact_id']) {
        $query->propertyCondition('contact_id', $params['contact_id'], '=');
    }

    if ($params['session_backend_fingerprint']) {
        $query->propertyCondition('session_backend_fingerprint', $params['session_backend_fingerprint'], '=');
    }

    if ($params['email']) {
        $query->propertyCondition('email', $params['email'], '=');
    }


    if ($params['limit']) {
        $query->range = array(
            'start' => 0,
            'length' => $params['limit'],
        );
    } else {
        $query->range = array(
            'start' => 0,
            'length' => 1000,
        );
    }

    //->propertyCondition('language', $GLOBALS['language']->language);
    //->fieldCondition('field_news_types', 'value', 'spotlight', '=')
    //->fieldCondition('field_photo', 'fid', 'NULL', '!=')
    //->fieldCondition('field_faculty_tag', 'tid', $value)
    //->fieldCondition('field_news_publishdate', 'value', $year. '%', 'like')
    $query->propertyOrderBy('updated', 'DESC');
    //->range(0, 10)
    //->addMetaData('account', user_load(1)); // Run the query as user 1.
    //$query->addMetaData('debug', 'debug'); // Run the query as user 1.
    $query->addTag('debug'); // Run the query as user 1.

    if ($params['returncount'] == true) {
        return $query->count()->execute();
    }
    $result = $query->execute();

    if (isset($result['inbound_session'])) {
        $item_ids = array_keys($result['inbound_session']);
        $entities = entity_load('inbound_session', $item_ids);
        // Filter Out the unwished data
        foreach ($entities as $entity) {
            $session_data = json_decode($entity->session_data);
            if ($session_data->agent != ''
                //&& strpos($session_data->agent,'Mozilla')
                //&& strpos($session_data->agent,'Mozilla')
                //&& count($session_data->hits) > 1
                ) {
                $data[] = $entity;
            }
        }
    }
    //debug_raw($entities);
    return $entities;
}

function inbound_session_query_alter($query) {
    if ($query->hasTag('debug')) {
        //echo (string)$query;
        //debug_raw((string)$query);
    }
}