<?php
function inbound_session_hit_api_find($params = array()) {
    //debug_raw($params);

    $item_nids = array();
    $query = new EntityFieldQuery();
    $query->entityCondition('entity_type', 'inbound_session_hit');

    if ($params['from']) {
        $query->propertyCondition('created', $params['from'], '>=');
    }

    if ($params['to']) {
        $query->propertyCondition('created', $params['to'], '<=');
    }

    if ($params['contact_id']) {
        $query->propertyCondition('contact_id', $params['contact_id'], '=');
    }

    if ($params['session_id']) {
        $query->propertyCondition('session_id', $params['session_id'], '=');
    }

    if ($params['event']) {
        $query->propertyCondition('event', $params['event'], '=');
    }

    if ($params['event_value']) {
        $query->propertyCondition('event_value', $params['event_value'], '=');
    }


    $query->range = array(
        'start' => 0,
        'length' => 4000,
    );

    $query->propertyOrderBy('created', 'DESC');

    if ($params['returncount'] == true) {
        return $query->count()->execute();
    }
    $result = $query->execute();

    if (isset($result['inbound_session_hit'])) {
        $item_ids = array_keys($result['inbound_session_hit']);
        $entities = entity_load('inbound_session_hit', $item_ids);
    }

    return $entities;
}